
Foreman - Bug #6216

Trying to delete a subnet that is associated with a host group throws foreign key error

06/13/2014 04:06 PM - Dominic Cleal

Status: Closed   

Priority: Low   

Assignee: Joseph Magen   

Category: Rails   

Target version: 1.5.2   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link: 1109315 Red Hat JIRA:  

Pull request:    

Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1109315

Description of problem:

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:

1.  Manually create a subnet ('mysubnet', 192.168.100.1, 255.255.255.0)

2.  Associate this subnet with a hostgroup

3.  Try to delete the subnet

Actual results:

Oops, we're sorry but something went wrong

×

Error

ERROR: update or delete on table "subnets" violates foreign key constraint "hostgroups_subnet_id_fk" on table "hostgroups"

DETAIL: Key (id)=(2) is still referenced from table "hostgroups".

If you feel this is an error with Foreman itself, please open a new issue with Foreman ticketing system, You would probably need to

attach the Full trace and relevant log entries.

Expected results:

A handled exception and perhaps a UI block on trying to delete a subnet that is already associated.

Additional info:

Associated revisions

Revision e0d618ef - 06/24/2014 08:18 AM - Joseph Magen

fixes #6216, #4416 - avoid foreign key errors when deleting some objects in use

Revision 3d5d2c5c - 07/28/2014 07:20 AM - Joseph Magen

fixes #6216, #4416 - avoid foreign key errors when deleting some objects in use

(cherry picked from commit e0d618efa6a8c02b46000bfcb9ded5eb672a6e13)

History

#1 - 06/13/2014 04:07 PM - Dominic Cleal

- Category set to Rails

Missing an EnsureNotUsedBy.new(:hostgroups) on the subnet.  Worth double checking all other foreign keys have similar before_destroy hooks for

friendly errors.
#2 - 06/15/2014 01:59 PM - Joseph Magen

- Status changed from New to Assigned

- Assignee set to Joseph Magen

- Target version set to 1.8.1

#3 - 06/15/2014 02:17 PM - Joseph Magen

- Status changed from Assigned to Ready For Testing

https://github.com/theforeman/foreman/pull/1513

I suggest to have Ori review other places foreign keys are missing before_destroy EnsureNotUsedBy.new

#4 - 06/24/2014 08:17 AM - Dominic Cleal

- translation missing: en.field_release set to 18

#5 - 06/24/2014 08:31 AM - Joseph Magen

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset e0d618efa6a8c02b46000bfcb9ded5eb672a6e13.
